/* This file cannot be compiled on its own
   It contains (still broken) FP routines that are
   automatically appended to rtl_sched.c by make
   */
static int rtl_linux_saved_ts;
static void rtl_fpu_task_init(RT_TASK *t, RT_TASK *current_t)
{
        t->uses_fp = 1;
	/* this should be called in the Linux kernel context
	   so we  must save/restore the linux fpu state*/
	__asm__("fsave %0" : "=m" (current_t->fpu_regs));
	__asm__("finit");
	__asm__("fsave %0" : "=m" (t->fpu_regs));
	__asm__("frstor %0" : "=m" (current_t->fpu_regs));
	return ;
}

static void rtl_fpu_switch(RT_TASK *new_t, RT_TASK *current_t){
        {static int d =1; if(d){conpr("FP switch\n");d=0;}}
	if(new_t != current_t){
		if(current_t->uses_fp)/*save & do exceptions on current stk*/
			__asm__("fsave %0" : "=m" (current_t->fpu_regs));
		
		/* now restore fpu state of new, assume new uses fp */
		__asm__("frstor %0" : "=m" (new_t->fpu_regs));
		/* if the current task is linux, save the TS bit 
		   if the _new_ task is linux restore the saved TS
		   at most one of these is true */
		if(rtl_is_linux_task(current_t))
		    __asm__("movl %%cr0,%%eax;andl $8,%%eax;movl %%eax,%0" \
				    :"=m" (rtl_linux_saved_ts)/*output*/ \
				    : /* no inputs */ \
				    :"ax");
		else if(rtl_is_linux_task(new_t) && rtl_linux_saved_ts)
			stts();
	}
}
static void rtl_fpu_task_delete(RT_TASK *task){
	/* maybe we should do something here? */
}

static void rtl_fpu_init(){
rtl_linux_task.uses_fp = 1;
}


